searchNodes=[{"ref":"Pravda.html","title":"Pravda","type":"module","doc":"Validates input and output according to an OpenAPI specs. Usage: Add the plug at the bottom of one or more pipelines in router.ex: pipeline &quot;api&quot; do # ... plug Pravada.Plugs.Validate, specs: [ &quot;some_spec.json&quot; ] end"},{"ref":"Pravda.html#attempt_validate_response/5","title":"Pravda.attempt_validate_response/5","type":"function","doc":"attempt_validate_response checks to see if we are going to attempt to validate a response before we send it out."},{"ref":"Pravda.html#call/2","title":"Pravda.call/2","type":"function","doc":"Call function we attempt to validate params, then body, then our response body. and we return based on if we allow invalid input/output and the validity of the content"},{"ref":"Pravda.html#closest_input_version/2","title":"Pravda.closest_input_version/2","type":"function","doc":""},{"ref":"Pravda.html#get_closest_input_schema_with_version/2","title":"Pravda.get_closest_input_schema_with_version/2","type":"function","doc":""},{"ref":"Pravda.html#init/1","title":"Pravda.init/1","type":"function","doc":"Init function sets all default variables and compiles the spec and paths so it can be fast. at run time."},{"ref":"Pravda.html#version/0","title":"Pravda.version/0","type":"function","doc":"Returns the version of the currently loaded Pravda, in string format."},{"ref":"Pravda.html#t:open_api_spec/0","title":"Pravda.open_api_spec/0","type":"type","doc":""},{"ref":"Pravda.html#t:path/0","title":"Pravda.path/0","type":"type","doc":""},{"ref":"Pravda.html#t:path_regex/0","title":"Pravda.path_regex/0","type":"type","doc":""},{"ref":"Pravda.Core.html","title":"Pravda.Core","type":"module","doc":"Documentation for Pravda core."},{"ref":"Pravda.Core.html#compile_paths/1","title":"Pravda.Core.compile_paths/1","type":"function","doc":"Compile Paths is the function used to take a list of spec files and compile them into a list of routes we can validate with."},{"ref":"Pravda.Core.html#deref_if_possible/2","title":"Pravda.Core.deref_if_possible/2","type":"function","doc":""},{"ref":"Pravda.Core.html#phoenix_route_to_schema/2","title":"Pravda.Core.phoenix_route_to_schema/2","type":"function","doc":"phoenix_route_to_schema takes a connections current path location and method and outputs a url that will match an openapi schema base definition it uses the router to correctly resolve the name and order of path arguments"},{"ref":"Pravda.Core.html#validate_body/3","title":"Pravda.Core.validate_body/3","type":"function","doc":"validate_body is used to validate the input body for a spec, for a specific method, path."},{"ref":"Pravda.Core.html#validate_params/5","title":"Pravda.Core.validate_params/5","type":"function","doc":"validate params takes in and validates headers, path, and query parameters against the spec"},{"ref":"Pravda.Core.html#validate_response/4","title":"Pravda.Core.validate_response/4","type":"function","doc":"validate_response is used to validate the responses section for a spec, for a specific method, path, and status."},{"ref":"Pravda.Helpers.Template.html","title":"Pravda.Helpers.Template","type":"module","doc":"This handles the stock default templating for Pravda, outputting several stock error messages"},{"ref":"Pravda.Helpers.Template.html#get_stock_code/1","title":"Pravda.Helpers.Template.get_stock_code/1","type":"function","doc":"Returns the http status code for a given class of error"},{"ref":"Pravda.Helpers.Template.html#get_stock_message/2","title":"Pravda.Helpers.Template.get_stock_message/2","type":"function","doc":"Returns the response body for a given state"},{"ref":"Pravda.Loader.html","title":"Pravda.Loader","type":"module","doc":"This loads the spec into a compiled binary. It is useful as the specs might not be available in the priv folder or on the deployed machine. this way we build up the spec file at compile time and not at run time."},{"ref":"Pravda.Loader.html#load/1","title":"Pravda.Loader.load/1","type":"function","doc":""},{"ref":"Pravda.Loader.html#read_dir/1","title":"Pravda.Loader.read_dir/1","type":"macro","doc":""},{"ref":"Pravda.Loader.html#read_file/1","title":"Pravda.Loader.read_file/1","type":"macro","doc":"Read_file exposes the macro that allows you to point to any local file and have it be part of the deploy on release."},{"ref":"Pravda.Loader.html#recursive_read/1","title":"Pravda.Loader.recursive_read/1","type":"function","doc":""},{"ref":"Pravda.RemoteResolver.html","title":"Pravda.RemoteResolver","type":"module","doc":"Remote Resolver is used by ex_json_schema to presolve remote refs over http"},{"ref":"Pravda.RemoteResolver.html#resolve/1","title":"Pravda.RemoteResolver.resolve/1","type":"function","doc":"resolve json schema."},{"ref":"readme.html","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix.","type":"extras","doc":"Pravda: An OpenAPI 3.0 validator plug for phoenix. Pravda is a plug for phoenix to validate input and output against a provided spec. It also supports having multiple versions of the same spec lodaded at one time, and the ability to migrate the input version to the current spec, and downgrade the output to the desired sepc. It supports custom error messages via callbacks, and extra logging via callback as well. Metrics are implemented via telemetry."},{"ref":"readme.html#example","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Example","type":"extras","doc":"plug(Pravda, %{ spec_var: &quot;spec-version&quot;, all_paths_required: true, error_callback: MyApp.Utils.PravdaErrorLogger, migration_callback: MyApp.Utils.PravdaMigrations, specs: Pravda.Loader.read_dir(&quot;deps/my_specs/suppored_releases&quot;), })"},{"ref":"readme.html#installation","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Installation","type":"extras","doc":"Add the following to the deps block in mix.exs: {:pravda, &quot;~&gt;0.6.0&quot;}"},{"ref":"readme.html#configuration","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Configuration","type":"extras","doc":"Configuration can be specified in the opts argument to all Pravda functions, by setting config values with e.g., Application.put_env, or by a combination of the two. The following configuration options are supported: :name a namespace for all other options so you can have multiple instances of the plug. Default Pravda.DefaultName :enable enable or disable the plug entirely. Default true. :specs List of files to use for validation, :spec_var Name of the spec-var we are matching against. Default &quot;spec-var&quot; :spec_var_placement the location of the spec var. Options are :query, :path, :header Default :header :migration_callback Module to be passed in that will be called when the spec is attempted to migrate Default nil :error_callback Module to be passed in that will be called when there is an error in the input or output, Default: nil :custom_error_callback Module to be passed in that will provide enduser with a custom error message, Default: nil :all_paths_required The path passed into the plug must match one of its rules if true, Default: :true :explain_error provide the reason validation failed, Default: true :validate_params validate input params, header, path, query, Default: true :validate_body validate input body from user, Default: true :validate_response validate output response to the user, Default: true :allow_invalid_input allow input to pass even if it fails validation, Default: false :allow_invalid_output allow output to pass even if it fails validation, Default: false :migrate_input migrate input from current spec to latest input spec, Default: true :migrate_output migrate output from current spec to client requested spec, Default: true TODO :fallback_to_latest migrate output to latest if true, otherwise fallback to oldest supported version, Default: true"},{"ref":"readme.html#metrics","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Metrics","type":"extras","doc":"Metrics are offered via the Telemetry library. The following metrics are emitted: [:pravda, :request, :params, :valid] Successfully validated input parameters [:pravda, :request, :params, :invalid] Input parameters failed to validate [:pravda, :request, :body, :valid] Successfully validated body [:pravda, :request, :body, :invalid] Input body failed to validate [:pravda, :request, :response, :valid] Successfully validated output response [:pravda, :request, :response, :invalid] Output response failed to validate [:pravda, :request, :migrate, :up] Successfully migrated input spec up [:pravda, :request, :migrate, :down] Successfully migrated output spec down [:pravda, :request, :complete] Request made it through the plug [:pravda, :request, :start] Request made it into the plug"},{"ref":"readme.html#contributing","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Contributing","type":"extras","doc":"Thanks for considering contributing to this project, and to the free software ecosystem at large! Interested in contributing a bug report? Terrific! Please open a GitHub issue and include as much detail as you can. If you have a solution, even better -- please open a pull request with a clear description and tests. Have a feature idea? Excellent! Please open a GitHub issue for discussion. Want to implement an issue that&#39;s been discussed? Fantastic! Please open a GitHub pull request and write a clear description of the patch. We&#39;ll merge your PR a lot sooner if it is well-documented and fully tested."},{"ref":"readme.html#authorship-and-license","title":"Pravda: An OpenAPI 3.0 validator plug for phoenix. - Authorship and License","type":"extras","doc":"Copyright 2020, Matthew O&#39;Gorman. This software is released under the MIT License."}]